import BaseService from './BaseService';

export default class BaseServiceCrudProper extends BaseService {
	// Initializing important variables
	constructor(domain) {
		super(domain);
		this.getList = this.getList.bind(this);
		this.get = this.get.bind(this);
		this.add = this.add.bind(this);
		this.update = this.update.bind(this);
	}

	add(element) {
		// Get a token from api server using the fetch api
		return this.fetch(`${this.domain}/${this.path}`, {
			method: 'POST',
			body: JSON.stringify(element),
		}).then(res => {
			return Promise.resolve(res);
		});
	}

	update(element) {
		// Get a token from api server using the fetch api
		return this.fetch(`${this.domain}/${this.path}/${element.id}`, {
			method: 'PUT',
			body: JSON.stringify(element),
		}).then(res => {
			return Promise.resolve(res);
		});
	}

	get(id, viewMode) {
		// Get a token from api server using the fetch api
		let path = `${this.domain}/${this.path}/${id}`;
		if (viewMode) {
			path += `?viewMode=${viewMode}`;
		}
		return this.fetch(path, {
			method: 'GET',
		}).then(res => {
			return Promise.resolve(res);
		});
	}

	getList(searchCriteria) {
		const criteria = {};
		Object.assign(criteria, searchCriteria);
		if (this.fieldToSortField) {
			criteria.sortField = this.fieldToSortField(criteria.sortField);
		}
		return this.fetch(`${this.domain}/${this.path}/filter`, {
			method: 'POST',
			body: JSON.stringify(criteria),
		}).then(res => {
			return Promise.resolve(res);
		});
	}
}
