/* eslint-disable no-undef */
/* eslint-disable no-unused-vars */
/* eslint-disable react/destructuring-assignment */
/* eslint-disable prefer-const */
/* eslint-disable react/jsx-handler-names */
import React from 'react';
import PropTypes from 'prop-types';
import DomHandler from 'primereact/components/utils/DomHandler';
import ObjectUtils from 'primereact/components/utils/ObjectUtils';
import Tooltip from 'primereact/tooltip';
import classNames from 'classnames';
import MultiSelectPanel from './MultiSelectPanel';
import MultiSelectItem from './MultiSelectItem';
import MultiSelectHeader from './MultiSelectHeader';

export class MultiSelect extends React.Component {
	constructor(props) {
		super(props);
		this.state = {
			filter: '',
		};

		this.onClick = this.onClick.bind(this);
		this.onPanelClick = this.onPanelClick.bind(this);
		this.onOptionClick = this.onOptionClick.bind(this);
		this.onOptionKeyDown = this.onOptionKeyDown.bind(this);
		this.onFocus = this.onFocus.bind(this);
		this.onBlur = this.onBlur.bind(this);
		this.onFilter = this.onFilter.bind(this);
		this.onCloseClick = this.onCloseClick.bind(this);
		this.onToggleAll = this.onToggleAll.bind(this);
		this.onInputKeyDown = this.onInputKeyDown.bind(this);
		this.onHeaderKeyDown = this.onHeaderKeyDown.bind(this);
		this.onHeaderClearKeyDown = this.onHeaderClearKeyDown.bind(this);
	}

	componentDidMount() {
		if (this.props.tooltip) {
			this.renderTooltip();
		}
	}

	componentDidUpdate(prevProps) {
		if (prevProps.tooltip !== this.props.tooltip) {
			if (this.tooltip) this.tooltip.updateContent(this.props.tooltip);
			else this.renderTooltip();
		}
	}

	componentWillUnmount() {
		this.unbindDocumentClickListener();

		if (this.tooltip) {
			this.tooltip.destroy();
			this.tooltip = null;
		}
	}

	onOptionClick(event) {
		let optionValue = this.getOptionValue(event.option);
		let selectionIndex = this.findSelectionIndex(optionValue);
		let newValue;

		if (selectionIndex !== -1) newValue = this.props.value.filter((val, i) => i !== selectionIndex);
		else newValue = [...(this.props.value || []), optionValue];

		this.updateModel(event.originalEvent, newValue);
	}

	onOptionKeyDown(event) {
		let originalEvent = event.originalEvent ? event.originalEvent : event;
		let listItem = originalEvent.currentTarget;

		switch (originalEvent.which) {
			// down
			case 40:
				const nextItem = this.findNextItem(listItem);
				if (nextItem) {
					nextItem.focus();
				}

				originalEvent.preventDefault();
				break;

			// up
			case 38:
				const prevItem = this.findPrevItem(listItem);
				if (prevItem) {
					prevItem.focus();
				}

				originalEvent.preventDefault();
				break;

			// enter
			// space
			case 32:
			case 13:
				this.onOptionClick(event);
				originalEvent.preventDefault();
				break;
			// escape
			case 27:
				this.hide(true);
				this.onClickInvoked = false;
				this.onHideInvoked = true;
				break;
			// tab
			case 9:
				// trap keyboard
				originalEvent.preventDefault();
				// this.hide();
				this.trapFocus(originalEvent);
				break;
			default:
				break;
		}
	}

	onHeaderKeyDown(event) {
		console.log('onHeaderKeyDown');
		let originalEvent = event.originalEvent ? event.originalEvent : event;
		switch (originalEvent.which) {
			// enter
			// space
			case 32:
			case 13:
				this.onOptionClick(event);
				originalEvent.preventDefault();
				break;
			// escape
			case 27:
				this.hide(true);
				this.onClickInvoked = false;
				this.onHideInvoked = true;
				break;
			// tab
			case 9:
				// trap keyboard
				originalEvent.preventDefault();
				// this.hide();
				this.trapFocus(originalEvent);
				break;
			default:
				break;
		}
	}

	onHeaderClearKeyDown(event) {
		console.log('onHeaderClearKeyDown');
		let originalEvent = event.originalEvent ? event.originalEvent : event;
		switch (originalEvent.which) {
			// enter
			// space
			// escape
			case 32:
			case 13:
			case 27:
				this.hide(true);
				this.onClickInvoked = false;
				this.onHideInvoked = true;
				break;
			// tab
			case 9:
				// trap keyboard
				originalEvent.preventDefault();
				// this.hide();
				this.trapFocus(originalEvent);
				break;
			default:
				break;
		}
	}

	trapFocus(event) {
		const focusableElements = DomHandler.getFocusableElements(this.panel.element);
		if (focusableElements && focusableElements.length > 0) {
			if (!document.activeElement) {
				focusableElements[0].focus();
			} else {
				const focusedIndex = focusableElements.indexOf(document.activeElement);

				if (event.shiftKey) {
					if (focusedIndex === -1 || focusedIndex === 0)
						focusableElements[focusableElements.length - 1].focus();
					else focusableElements[focusedIndex - 1].focus();
				} else {
					if (focusedIndex === -1 || focusedIndex === focusableElements.length - 1)
						focusableElements[0].focus();
					else focusableElements[focusedIndex + 1].focus();
				}
			}
		}
	}

	onInputKeyDown(event) {
		switch (event.which) {
			// space
			case 32:
				event.preventDefault();
				if (this.panel.element.offsetParent) {
					this.hide(focusInput);
				} else {
					this.focusInput.focus();
					this.show();
				}
				break;

			// enter
			case 13:
				this.hide(focusInput);
				event.preventDefault();
				break;

			// escape
			case 27:
				this.onClickInvoked = false;
				this.hide(focusInput);
				break;

			// tab
			case 9:
				this.hide();
				break;
		}
	}

	findNextItem(item) {
		let nextItem = item.nextElementSibling;

		if (nextItem)
			return !DomHandler.hasClass(nextItem, 'p-multiselect-item')
				? this.findNextItem(nextItem)
				: nextItem;
		else return null;
	}

	findPrevItem(item) {
		let prevItem = item.previousElementSibling;

		if (prevItem)
			return !DomHandler.hasClass(prevItem, 'p-multiselect-item')
				? this.findPrevItem(prevItem)
				: prevItem;
		else return null;
	}

	onClick() {
		console.log('onClick');
		if (this.props.disabled) {
			return;
		}
		this.onClickInvoked = true;

		if (this.documentClickListener) {
			this.selfClick = true;
		}

		if (!this.panelClick) {
			if (this.panel.element.offsetParent) {
				this.hide();
			} else {
				this.focusInput.focus();
				this.show();
				if (!this.props.disableAllChecked) {
					this.panel.element.children[0].children[1].children[0].children[0].focus();
				}
			}
		}
	}

	onToggleAll(event) {
		let newValue;

		if (event.checked) {
			newValue = [];
		} else {
			let options = this.hasFilter() ? this.filterOptions(this.props.options) : this.props.options;
			if (options) {
				newValue = [];
				for (let option of options) {
					newValue.push(this.getOptionValue(option));
				}
			}
		}

		this.updateModel(event.originalEvent, newValue);
	}

	updateModel(event, value) {
		if (this.props.onChange) {
			this.props.onChange({
				originalEvent: event,
				value,
				stopPropagation: () => {},
				preventDefault: () => {},
				target: {
					name: this.props.name,
					id: this.props.id,
					value,
				},
			});
		}
	}

	onFilter(event) {
		this.setState({ filter: event.query });
	}

	onPanelClick() {
		this.panelClick = true;
	}

	show() {
		if (this.props.options && this.props.options.length) {
			this.panel.element.style.zIndex = String(DomHandler.generateZIndex());
			this.panel.element.style.display = 'block';

			setTimeout(() => {
				DomHandler.addClass(this.panel.element, 'p-input-overlay-visible');
				DomHandler.removeClass(this.panel.element, 'p-input-overlay-hidden');
			}, 1);

			this.alignPanel();
			this.bindDocumentClickListener();
		}
	}

	hide(focusInput) {
		DomHandler.addClass(this.panel.element, 'p-input-overlay-hidden');
		DomHandler.removeClass(this.panel.element, 'p-input-overlay-visible');
		this.unbindDocumentClickListener();
		this.clearClickState();
		setTimeout(() => {
			this.panel.element.style.display = 'none';
			DomHandler.removeClass(this.panel.element, 'p-input-overlay-hidden');
			if (focusInput) {
				this.focusInput.focus();
			}
		}, 150);
	}

	alignPanel() {
		if (this.props.appendTo) {
			this.panel.element.style.minWidth = `${DomHandler.getWidth(this.container)}px`;
			DomHandler.absolutePosition(this.panel.element, this.container);
		} else {
			DomHandler.relativePosition(this.panel.element, this.container);
		}
	}

	onCloseClick(event) {
		this.hide();
		event.preventDefault();
		event.stopPropagation();
	}

	findSelectionIndex(value) {
		let index = -1;

		if (this.props.value) {
			for (let i = 0; i < this.props.value.length; i++) {
				if (ObjectUtils.equals(this.props.value[i], value, this.props.dataKey)) {
					index = i;
					break;
				}
			}
		}

		return index;
	}

	isSelected(option) {
		return this.findSelectionIndex(this.getOptionValue(option)) !== -1;
	}

	findLabelByValue(val) {
		let label = null;

		for (let i = 0; i < this.props.options.length; i++) {
			let option = this.props.options[i];
			let optionValue = this.getOptionValue(option);

			if (ObjectUtils.equals(optionValue, val)) {
				label = this.getOptionLabel(option);
				break;
			}
		}

		return label;
	}

	onFocus(event) {
		console.log('onFocus');
		DomHandler.addClass(this.container, 'p-focus');
		if (this.props.onFocus) {
			this.props.onFocus(event);
		}
		if (!this.panel.element.offsetParent && !this.onClickInvoked && !this.onHideInvoked) {
			if (this.props.disabled) {
				return;
			}
			this.focusInput.focus();
			setTimeout(() => {
				this.show();
				this.panel.element.children[0].children[1].children[0].children[0].focus();
			}, 200);
		}
		// this.onClickInvoked = true;
		this.onHideInvoked = false;
	}

	onBlur(event) {
		console.log('onBlur');
		DomHandler.removeClass(this.container, 'p-focus');
		if (this.props.onBlur) {
			this.props.onBlur(event);
		}
		this.onClickInvoked = false;
	}

	bindDocumentClickListener() {
		if (!this.documentClickListener) {
			this.documentClickListener = this.onDocumentClick.bind(this);
			document.addEventListener('click', this.documentClickListener);
		}
	}

	unbindDocumentClickListener() {
		if (this.documentClickListener) {
			document.removeEventListener('click', this.documentClickListener);
			this.documentClickListener = null;
		}
	}

	onDocumentClick() {
		if (!this.selfClick && !this.panelClick && this.panel.element.offsetParent) {
			this.hide();
		}

		this.clearClickState();
	}

	clearClickState() {
		this.selfClick = false;
		this.panelClick = false;
	}

	filterOption(option) {
		let filterValue = this.state.filter.trim().toLowerCase();
		let optionLabel = this.getOptionLabel(option);

		return optionLabel.toLowerCase().indexOf(filterValue.toLowerCase()) > -1;
	}

	hasFilter() {
		return this.state.filter && this.state.filter.trim().length > 0;
	}

	isAllChecked(visibleOptions) {
		if (this.hasFilter())
			return (
				this.props.value &&
				visibleOptions &&
				visibleOptions.length &&
				this.props.value.length === visibleOptions.length
			);
		else
			return (
				this.props.value &&
				this.props.options &&
				this.props.value.length === this.props.options.length
			);
	}

	filterOptions(options) {
		return options.filter(option => {
			return this.filterOption(option);
		});
	}

	getOptionValue(option) {
		return this.props.optionLabel ? option : option.value;
	}

	getOptionLabel(option) {
		return this.props.optionLabel
			? ObjectUtils.resolveFieldData(option, this.props.optionLabel)
			: option.label;
	}

	isEmpty() {
		return !this.props.value || this.props.value.length === 0;
	}

	getSelectedItemsLabel() {
		let pattern = /{(.*?)}/;
		if (pattern.test(this.props.selectedItemsLabel)) {
			return this.props.selectedItemsLabel.replace(
				this.props.selectedItemsLabel.match(pattern)[0],
				`${this.props.value.length}`
			);
		}

		return this.props.selectedItemsLabel;
	}

	getLabel(showAll) {
		let label;

		if (!this.isEmpty() && !this.props.fixedPlaceholder) {
			label = '';
			for (let i = 0; i < this.props.value.length; i++) {
				if (i !== 0) {
					label += ',';
				}
				label += this.findLabelByValue(this.props.value[i]);
			}

			if (this.props.value.length <= this.props.maxSelectedLabels || showAll) {
				return label;
			} else {
				return this.getSelectedItemsLabel();
			}
		}

		return label;
	}

	getLabelContent(showAll) {
		if (this.props.selectedItemTemplate) {
			if (!this.isEmpty()) {
				if (this.props.value.length <= this.props.maxSelectedLabels || showAll) {
					return this.props.value.map((val, index) => {
						return (
							<React.Fragment key={index}>{this.props.selectedItemTemplate(val)}</React.Fragment>
						);
					});
				} else {
					return this.getSelectedItemsLabel();
				}
			} else {
				return this.props.selectedItemTemplate();
			}
		} else {
			return this.getLabel(showAll);
		}
	}

	renderTooltip() {
		this.tooltip = new Tooltip({
			target: this.container,
			content: this.props.tooltip,
			options: this.props.tooltipOptions,
		});
	}

	renderHeader(items) {
		return (
			<MultiSelectHeader
				filter={this.props.filter}
				filterValue={this.state.filter}
				onFilter={this.onFilter}
				onClose={this.onCloseClick}
				onToggleAll={this.onToggleAll}
				disableAllChecked={this.props.disableAllChecked}
				onKeyDown={this.onHeaderKeyDown}
				onClearKeyDown={this.onHeaderClearKeyDown}
				allChecked={this.isAllChecked(items)}
				label={this.props.headerLabel}
				parentId={this.props.id}
				ariaLabel={this.props.ariaLabel}
			/>
		);
	}

	renderLabel() {
		const empty = this.isEmpty();
		const content = this.getLabelContent();
		const className = classNames('p-multiselect-label', {
			'p-placeholder': empty && this.props.placeholder,
			'p-multiselect-label-empty':
				empty && !this.props.placeholder && !this.props.selectedItemTemplate,
		});

		return (
			<div className="p-multiselect-label-container">
				<span className={className}>{content || this.props.placeholder || 'empty'}</span>
			</div>
		);
	}

	render() {
		let className = classNames('p-multiselect p-component', this.props.className, {
			'p-disabled': this.props.disabled,
		});
		let label = this.renderLabel();
		let items = this.props.options;

		if (items) {
			if (this.hasFilter()) {
				items = this.filterOptions(items);
			}

			items = items.map((option, index) => {
				let optionLabel = this.getOptionLabel(option);

				return (
					<MultiSelectItem
						key={`${optionLabel}_${index}`}
						label={optionLabel}
						option={option}
						template={this.props.itemTemplate}
						selected={this.isSelected(option)}
						onClick={this.onOptionClick}
						onKeyDown={this.onOptionKeyDown}
						tabIndex={this.props.tabIndex}
						optionDisabledField={this.props.optionDisabledField}
						optionDisabledReversed={this.props.optionDisabledReversed}
						optionsDisabled={this.props.optionsDisabled}
						ariaLabel={`${this.props.ariaLabel} ${optionLabel}`}
					/>
				);
			});
		}
		let header = this.renderHeader(items);
		const content = this.getLabelContent(true);
		return (
			<div
				id={this.props.id}
				className={className}
				onClick={this.onClick}
				ref={el => (this.container = el)}
				style={this.props.style}
			>
				<div className="p-hidden-accessible">
					<input
						ref={el => (this.focusInput = el)}
						id={this.props.inputId}
						type="text"
						role="listbox"
						readOnly
						onFocus={this.onFocus}
						onBlur={this.onBlur}
						onKeyDown={this.onInputKeyDown}
						disabled={this.props.disabled}
						tabIndex={this.props.tabIndex}
						aria-label={`${this.props.ariaLabel} ${content || this.props.placeholder}`}
						// aria-live={'assertive'}
						aria-describedby={this.props.ariaDescribedBy}
						aria-labelledby={this.props.ariaLabelledBy}
						required={this.props.required}
						aria-required={this.props.required}
						aria-haspopup="listbox"
					/>
				</div>
				{label}
				<div className="p-multiselect-trigger">
					<span className="p-multiselect-trigger-icon pi pi-chevron-down p-c" />
				</div>
				<MultiSelectPanel
					ref={el => (this.panel = el)}
					header={header}
					appendTo={this.props.appendTo}
					onClick={this.onPanelClick}
					scrollHeight={this.props.scrollHeight}
				>
					{items}
				</MultiSelectPanel>
			</div>
		);
	}
}

MultiSelect.defaultProps = {
	id: null,
	value: null,
	options: null,
	optionLabel: null,
	style: null,
	className: null,
	scrollHeight: '200px',
	placeholder: null,
	fixedPlaceholder: false,
	disableAllChecked: false,
	disabled: false,
	filter: false,
	tabIndex: '0',
	dataKey: null,
	appendTo: null,
	tooltip: null,
	tooltipOptions: null,
	maxSelectedLabels: 3,
	selectedItemsLabel: '{0} items selected',
	ariaLabelledBy: null,
	itemTemplate: null,
	selectedItemTemplate: null,
	onChange: null,
	onFocus: null,
	onBlur: null,
	headerLabel: 'Wszystkie',
	optionDisabledReversed: false,
	optionsDisabled: false,
};

MultiSelect.propTypes = {
	appendTo: PropTypes.object,
	ariaDescribedBy: PropTypes.string,
	ariaLabel: PropTypes.string,
	ariaLabelledBy: PropTypes.string,
	className: PropTypes.string,
	dataKey: PropTypes.string,
	disableAllChecked: PropTypes.bool,
	disabled: PropTypes.bool,
	filter: PropTypes.bool,
	fixedPlaceholder: PropTypes.bool,
	headerLabel: PropTypes.string,
	id: PropTypes.string,
	inputId: PropTypes.string,
	itemTemplate: PropTypes.func,
	maxSelectedLabels: PropTypes.number,
	name: PropTypes.string,
	onBlur: PropTypes.func,
	onChange: PropTypes.func,
	onFocus: PropTypes.func,
	optionDisabledField: PropTypes.string,
	optionDisabledReversed: PropTypes.bool,
	optionLabel: PropTypes.string,
	options: PropTypes.array,
	optionsDisabled: PropTypes.bool,
	placeholder: PropTypes.string,
	required: PropTypes.bool,
	scrollHeight: PropTypes.string,
	selectedItemTemplate: PropTypes.func,
	selectedItemsLabel: PropTypes.string,
	style: PropTypes.object,
	tabIndex: PropTypes.string,
	tooltip: PropTypes.string,
	tooltipOptions: PropTypes.object,
	value: PropTypes.any,
};

export default MultiSelect;
